package com.steerinfo.dil.controller;
import com.steerinfo.dil.service.ITmstruckMeasureCommissionService;

import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstruckMeasureCommission RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-09 10:28
 * 类描述
 * 修订历史：
 * 日期：2021-09-09
 * 作者：generator
 * 参考：
 * 描述：TmstruckMeasureCommission RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tmstruckmeasurecommissions")
public class TmstruckMeasureCommissionController extends BaseRESTfulController {

    @Autowired
    ITmstruckMeasureCommissionService tmstruckMeasureCommissionService;

    @ApiOperation(value="查询计量委托 ")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "装车作业实绩ID", required = false, dataType = "Integer"),
    })
    @PostMapping("/getAllMeasureCommission/{type}")
    public RESTfulResult getAllMeasureCommission(@PathVariable("type") Integer type, Integer orderType){
        HashMap<String, Object> mapValue = new HashMap<>();
        mapValue.put("type", type);
        mapValue.put("orderType", orderType);
        List<Map<String, Object>> allMeasureCommission = tmstruckMeasureCommissionService.getAllMeasureCommission(mapValue);
        return success(allMeasureCommission);
    }

    @ApiOperation(value="查询计量委托 ")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "装车作业实绩ID", required = false, dataType = "Integer"),
    })
    @PostMapping("/sendMesToDXMeasure")
    public RESTfulResult sendMesToDXMeasure(@RequestBody(required = false) Map<String, Object> map){
        int i = tmstruckMeasureCommissionService.addMaoMeasureCommission(map);
        return success(i);
    }
    @ApiOperation(value="发送计量委托 ")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "装车作业实绩ID", required = false, dataType = "Integer"),
    })
    @PostMapping("/sendMeasureCommission")
    public RESTfulResult sendMeasureCommission(@RequestBody(required = false) Map<String, Object> map){
        int i = tmstruckMeasureCommissionService.sendMeasureCommssion(map);
        if(i == 0){
            return failed("委托发送失败！请联系管理员");
        }
        return success("委托发送成功");
    }


}
