package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.model.TmstruckQualityResult;
import com.steerinfo.dil.service.ITmstruckQualityResultService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstruckQualityResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-11 04:14
 * 类描述
 * 修订历史：
 * 日期：2021-09-11
 * 作者：generator
 * 参考：
 * 描述：TmstruckQualityResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tmstruckqualityresults")
public class TmstruckQualityResultController extends BaseRESTfulController {

    @Autowired
    ITmstruckQualityResultService tmstruckQualityResultService;

    @Autowired
    ESFeign esFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value="查询所有的质检作业")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(111)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQualityResult")
    public RESTfulResult getQualityResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                          Integer apiId,
                                          Integer pageNum,
                                          Integer pageSize,
                                          Integer orderType,
                                          String con
    ){
        mapValue.put("orderTypee", orderType);
        //框计算
        if(con != null){
            if(!"undefined".equals(con)){
                String index="get_quality_list";//设置要查询的索引名称
                return success(esFeign.getConResult(mapValue,index,apiId,pageNum,pageSize,con));//获取查询结果
            }
        }
        //不分页筛选数据
        List<Map<String, Object>> allQualityResult = null;
        //如果有条件查询则跳过初始化，和创建索引
        if(mapValue.size() == 0){
            //将查询结果存入索引中
            allQualityResult = tmstruckQualityResultService.getQualityResult(mapValue);
            DataChange.dataTo2Number(allQualityResult, "resultDeduction");
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index","get_quality_list");
            //添加id
            map.put("indexId","qualityId");
            allQualityResult.add(map);
            //新建索引
            esFeign.insertIndex(allQualityResult);
            //删除
            allQualityResult.remove(allQualityResult.size()-1);
        }
        if(allQualityResult == null)
            allQualityResult = tmstruckQualityResultService.getQualityResult(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> qualityResult = tmstruckQualityResultService.getQualityResult(mapValue);
        DataChange.dataTo2Number(qualityResult, "resultDeduction");
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allQualityResult,qualityResult);
        return success(pageList);
    }


    @ApiOperation(value="获取质检实绩 ")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "质检作业实绩ID", required = false, dataType = "Integer"),
    })
    @PostMapping("/getQualityResultById/{resultId}")
    public RESTfulResult getQualityResultById(@PathVariable("resultId") Integer resultId){
        List<Map<String, Object>> resultById = tmstruckQualityResultService.getQualityResultById(resultId);
        return success(resultById);
    }

    @ApiOperation(value="修改质检实绩 ")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "resultId", value = "质检作业实绩ID", required = false, dataType = "Integer"),
    })
    @PostMapping("/updateQualityResult")
    public RESTfulResult updateQualityResult(@RequestBody TmstruckQualityResult tmstruckQualityResult){
        int i = tmstruckQualityResultService.updateQualityResult(tmstruckQualityResult);
        return success(i);
    }
}
