package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.service.ITmstruckReturnResultService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;

import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstruckReturnResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-18 09:17
 * 类描述
 * 修订历史：
 * 日期：2021-10-18
 * 作者：generator
 * 参考：
 * 描述：TmstruckReturnResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tmstruckreturnresults")
public class TmstruckReturnResultController extends BaseRESTfulController {

    @Autowired
    ITmstruckReturnResultService tmstruckReturnResultService;

    @Autowired
    ESFeign esFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value = "新增退货实绩", notes = "需要运输订单号")
    @PostMapping(value = "/addReturnGoodsResult")
    public RESTfulResult addReturnGoodsResult(@RequestBody(required = false) Map<String, Object> map) {
        int i = tmstruckReturnResultService.addReturnGoodsResult(map);
        return success(i);
    }

    @ApiOperation(value="查询所有的退货实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId()", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getAllReturnResult")
    public RESTfulResult getAllReturnResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize,
                                               Integer orderType,
                                               String con
    ){
        mapValue.put("orderTypee", orderType);
        //框计算
        if(con != null){
            if(!"undefined".equals(con)){
                //设置要查询的索引名称
                String index="get_return_list";
                //获取查询结果
                return success(esFeign.getConResult(mapValue,index,apiId,pageNum,pageSize,con));
            }
        }
        List<Map<String, Object>> AllReturnResult = null;
        //如果有条件查询则跳过初始化，和创建索引
        if(mapValue.size() == 1){
            //将查询结果存入索引中
            AllReturnResult = tmstruckReturnResultService.getAllReturnResult(mapValue);
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index","get_return_list");
            //添加id
            map.put("indexId","returnId");
            AllReturnResult.add(map);
            //新建索引
            esFeign.insertIndex(AllReturnResult);
            //删除
            AllReturnResult.remove(AllReturnResult.size()-1);
        }
        if(AllReturnResult == null)
            AllReturnResult = tmstruckReturnResultService.getAllReturnResult(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> returnResult = tmstruckReturnResultService.getAllReturnResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, AllReturnResult,returnResult);
        return success(pageList);
    }
}
