package com.steerinfo.dil.controller;
import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.service.ITmstruckTimeTaskResultService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmstruckTimeTskResult RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-22 07:28
 * 类描述
 * 修订历史：
 * 日期：2021-10-22
 * 作者：generator
 * 参考：
 * 描述：TmstruckTimeTskResult RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/tmstrucktimetaskresults")
public class TmstruckTimeTaskResultController extends BaseRESTfulController {

    @Autowired
    ITmstruckTimeTaskResultService tmstruckTimeTaskResultService;

    @Autowired
    ESFeign esFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value="司机申请开始")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/applyStartTime")
    public RESTfulResult applyStartTime(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.applyStartTime(mapValue);
        return success(i);
    }

    @ApiOperation(value="用车单位确认开始")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/unitSureStartTime")
    public RESTfulResult unitSureStartTime(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.unitSureStartTime(mapValue);
        return success(i);
    }

    @ApiOperation(value="司机申请暂停开始")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/applyStartTimeout")
    public RESTfulResult applyStartTimeout(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.applyStartTimeout(mapValue);
        return success(i);
    }

    @ApiOperation(value="用车单位确认暂停申请开始")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/unitSureStartTimeout")
    public RESTfulResult unitSureStartTimeout(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.unitSureStartTimeout(mapValue);
        return success(i);
    }

    @ApiOperation(value="司机申请暂停结束")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/applyEndTimeout")
    public RESTfulResult applyEndTimeout(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.applyEndTimeout(mapValue);
        return success(i);
    }

    @ApiOperation(value="用车单位确认暂停结束")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/unitSureEndTimeout")
    public RESTfulResult unitSureEndTimeout(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.unitSureEndTimeout(mapValue);
        return success(i);
    }

    @ApiOperation(value="司机申请结束")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/applyEndTime")
    public RESTfulResult applyEndTime(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.applyEndTime(mapValue);
        return success(i);
    }

    @ApiOperation(value="用车单位确认结束")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "运输订单号", required = false, dataType = "Map"),
    })
    @PostMapping("/unitSureEndTime")
    public RESTfulResult unitSureEndTime(@RequestBody(required=false) Map<String,Object> mapValue){
        int i = tmstruckTimeTaskResultService.unitSureEndTime(mapValue);
        return success(i);
    }

    @ApiOperation(value="查询计皮实绩")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "mapValue", value = "表头和参数", required = false, dataType = "map"),
            @ApiImplicitParam(name = "apiId(363)", value = "动态表头", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageNum", value = "页码", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "页", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "status", value = "状态码", required = false, dataType = "Integer"),
    })
    @PostMapping("/getAllTimeTaskResult")
    public RESTfulResult getAllTimeTaskResult(@RequestBody(required=false) Map<String,Object> mapValue,
                                          Integer apiId,
                                          Integer pageNum,
                                          Integer pageSize,
                                          String con
    ){

        //框计算
        if(con != null){
            if(!"undefined".equals(con)){
                String index="get_time_task_list";//设置要查询的索引名称
                return success(esFeign.getConResult(mapValue,index,apiId,pageNum,pageSize,con));//获取查询结果
            }
        }
        //不分页筛选数据
        List<Map<String, Object>> allResult = null;
        //如果有条件查询则跳过初始化，和创建索引
        if(mapValue.size() == 1){
            //将查询结果存入索引中
            allResult = tmstruckTimeTaskResultService.getAllTimeTaskResult(mapValue);
            Map<String, Object> map = new HashMap<>();
            //添加索引
            map.put("index","get_time_task_list");
            //添加id
            map.put("indexId","timeTaskId");
            allResult.add(map);
            //新建索引
            esFeign.insertIndex(allResult);
            //删除
            allResult.remove(allResult.size()-1);
        }
        if(allResult == null){
            allResult = tmstruckTimeTaskResultService.getAllTimeTaskResult(mapValue);
        }
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> result = tmstruckTimeTaskResultService.getAllTimeTaskResult(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, allResult,result);
        return success(pageList);
    }

}
