package com.steerinfo.dil.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.steerinfo.dil.mapper.RulesMapper;
import com.steerinfo.dil.mapper.TmstruckMeasureCommissionMapper;
import com.steerinfo.dil.mapper.UtilsMapper;
import com.steerinfo.dil.model.TmstruckMeasureCommission;
import com.steerinfo.dil.service.ITmstruckMeasureCommissionService;
import com.steerinfo.dil.util.DataChange;
import com.steerinfo.dil.util.HTTPRequestUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.*;

/**
 * TmstruckMeasureCommission服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-09 10:28
 * 类描述
 * 修订历史：
 * 日期：2021-09-09
 * 作者：generator
 * 参考：
 * 描述：TmstruckMeasureCommission服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmstruckMeasureCommissionService")
public class TmstruckMeasureCommissionServiceImpl implements ITmstruckMeasureCommissionService{

    @Autowired
    private TmstruckMeasureCommissionMapper tmstruckMeasureCommissionMapper;

    @Autowired
    private RulesMapper rulesMapper;
    @Autowired
    UtilsMapper utilsMapper;
    @Autowired
    private RulesServiceImpl rulesService;
   /**
     * 查询计量委托 0 ：计皮     1：计毛
     * @param map orderTypee 订单类型   type 是计皮还是计毛
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllMeasureCommission(Map<String, Object> map) {
        Integer orderType = (Integer) map.get("orderTypee");
        switch (orderType){
            case 1:

                break;
            case 2:

                break;
            case 3:

                break;
            case 4:

                break;
            case 5:
                break;
            case 6:
                break;
            case 7:
                break;
            case 8:
                return tmstruckMeasureCommissionMapper.getMeasureCommission(map);
            case 9:
                break;
            case 10:
                break;
            case 11:
        }
        return null;
    }

    /**
     * 添加计量委托 并发送采购订单计量委托
     * @param map {orderTypee: 订单类型
     *            resultTotalId：总实绩ID  orderId: 订单ID
     *            总实绩ID }
     * @return
     */
    public int addMaoMeasureCommission(Map<String, Object> map){
        int i = 0;
        addMeasureCommission(map); // 添加计毛委托
        //发送数据给计量系统 必要数据 orderTypee：订单类型  resultTotalId： 总实绩Id   orderId
        int orderType = DataChange.dataToBigDecimal(map.get("orderTypee")).intValue();
        if(orderType == 10){
            //获取当前订单是属于哪个厂区订单
            Integer receiveId = tmstruckMeasureCommissionMapper.getReceiveIdByRequirementOrderId(DataChange.dataToBigDecimal(map.get("orderId")));
            if(receiveId == 1){
                i += sendMeasureCommissionMes(map);  //发送委托给达州钢铁
            }else if(receiveId == 2) {
                i += sendDXMeasureCommissionMes(map); //发送委托给达兴能源
            }
        }else if(orderType == 6 || orderType == 5 || orderType == 11){
            //发送委托给达州钢铁
            i += sendMeasureCommissionMes(map);
        }else if(orderType == 18 || orderType == 7) {
            //发送委托给达兴能源
            i += sendDXMeasureCommissionMes(map);
        }

        return i;
    }


    /**
     * 发送销售订单计量委托
     * @param map
     * @return
     */
    public int addXSMeasureCommission(Map<String, Object> map){
        int i = 0;
        addMeasureCommission(map); // 添加计毛委托
        //发送数据给计量系统 必要数据 orderTypee：订单类型  resultTotalId： 总实绩Id   orderId
        //获取当前订单是属于哪个厂区订单
        Integer shipperId = tmstruckMeasureCommissionMapper.getShipperIdByOrderId(DataChange.dataToBigDecimal(map.get("orderId")));
        if(shipperId == 1){
            //发送委托给达州钢铁
            i += sendMeasureCommissionMes(map);
        }
        if(shipperId == 2) {
            //发送委托给达兴能源
            i += sendDXMeasureCommissionMes(map);
        }
        return i;
    }

    /**
     * 添加零星物资计量委托
     * @param map
     * @return
     */
    public int addLXMeasureCommission(Map<String, Object> map){
        Integer orderType = DataChange.dataToBigDecimal(map.get("orderTypee")).intValue();
        BigDecimal orderId = DataChange.dataToBigDecimal(map.get("orderId"));
        int i = 0;
        if(orderType == 12) {
            //查询进厂收货单位
            Integer receiveId = tmstruckMeasureCommissionMapper.getLxRealReceiveIdByOrderId(orderId);
            if(receiveId == 1){
                //给达钢发送委托
                i = sendMeasureCommissionMes(map);
            }else if(receiveId == 2){
                //给达兴发送委托
                i = sendDXMeasureCommissionMes(map);
            }
        }else if(orderType == 13){
            Integer sendId = tmstruckMeasureCommissionMapper.getLxRealSendUnitIdByOrderId(orderId);
            if(sendId == 1){
                i = sendMeasureCommissionMes(map);
            }else if(sendId == 2){
                i = sendDXMeasureCommissionMes(map);
            }

        }else if(orderType == 15){
            //进厂,收货单位
            //如果是15类型的订单寻找订单父级发货单位  (现只有进厂)
            Integer receiveId = tmstruckMeasureCommissionMapper.getLxRealReceiveIdByOrderId(orderId);
            if(receiveId == 1){
                i = sendMeasureCommissionMes(map);
            }else if (receiveId == 2){
                i = sendDXMeasureCommissionMes(map);
            }
        }else if(orderType == 16){
            //出厂,发货单位
            Integer sendUnitId = tmstruckMeasureCommissionMapper.getLxRealSendUnitIdByOrderId(orderId);
            if(sendUnitId == 1){
                i = sendMeasureCommissionMes(map);
            }else if (sendUnitId == 2){
                i = sendDXMeasureCommissionMes(map);
            }
        }
        else if(orderType == 20) {//内转零星进厂
            //查询还未计量实绩
            Integer noNetWeightResult = rulesMapper.getNoNetWeightResult(orderId);
            if(noNetWeightResult != 2){
                i = sendMeasureCommissionMes(map);
            }else {
                i = sendDXMeasureCommissionMes(map);//如果有两条没有净重的实绩则需要给达兴发委托  否则给达钢发委托
            }
        }
        addMeasureCommission(map); // 添加计毛委托
        return i;
    }


    /**
     * 新增计毛、计皮委托
     * @return
     */
    @Override
    public int addMeasureCommission(Map<String, Object> map) {
        TmstruckMeasureCommission tmstruckMeasureCommission = new TmstruckMeasureCommission();
        //生成主键Id
        tmstruckMeasureCommission.setCommssionId(tmstruckMeasureCommissionMapper.selectMaxId());
        //添加物资ID
        tmstruckMeasureCommission.setMaterialId(DataChange.dataToBigDecimal(map.get("materialId")));
        //添加汽车衡Id
        if(map.get("grossPlaceId") != null){
            tmstruckMeasureCommission.setCalculateId(DataChange.dataToBigDecimal(map.get("grossPlaceId")));
        }
        if(map.get("tarePlaceId") != null){
            tmstruckMeasureCommission.setCalculateId(DataChange.dataToBigDecimal(map.get("tarePlaceId")));
        }
        //添加实绩总表Id
        tmstruckMeasureCommission.setResultTotalId(DataChange.dataToBigDecimal(map.get("resultTotalId")));
        tmstruckMeasureCommission.setInsertTime(new Date());
        tmstruckMeasureCommission.setInsertUsername("admin");
        return tmstruckMeasureCommissionMapper.insertSelective(tmstruckMeasureCommission);
    }


    /**
     * 查询计量委托并向计量系统发送数据  调用他们接口 (老厂区）
     * 1：销售订单；2：焦炭发运计划；3：水渣发运计划；4：内转到异地库；5：采购辅料订单；6：采购老区燃料订单；
     * 7：采购新区燃料订单；8：采购进口矿(万州-厂内)；9：采购内转(达州-厂内)；10：采购内转(老区-厂内)； 11：厂内内转
     * @param map orderTypee 订单类型  type 计皮0还是计毛1类型  orderId  订单ID
     */
    public int sendMeasureCommissionMes(Map<String, Object> map){
        Map<String, Object> measureCommission = null;
        //查询计量委托
        Integer orderType = DataChange.dataToBigDecimal(map.get("orderTypee")).intValue();
        switch (orderType){
            case 1:
                break;
            case 2:
                break;
            case 3:
                break;
            case 10:
                break;
            case 4:
                break;
            case 5:
            case 6:
            case 7:
            case 8:
//            case 9:
                measureCommission =  tmstruckMeasureCommissionMapper.purchaseMeasure(map);
                if(measureCommission == null){
                    return 0;
                }
                if(orderType == 6){
                    measureCommission.put("isRelationEAS", false);
                }else {
                    measureCommission.put("isRelationEAS", true);
                }
                measureCommission.put("flowTo", "进厂");
                measureCommission.put("isDel", false);
                measureCommission.put("isInsert", true);
                measureCommission.put("IsAssembly", false);
                measureCommission.put("deliveryMethod", "磅重交货");
                measureCommission.put("packagesNum", 0);
                break;
            case 11:
                //纯内转发送计量委托
                measureCommission = tmstruckMeasureCommissionMapper.purchaseNzMeasure(map);
                if(measureCommission == null){
                    return 0;
                }
                if(map.get("deletedCommission") != null){
                    measureCommission.put("isDel", true);
                    measureCommission.put("isInsert", false);
                }else {
                    measureCommission.put("isDel", false);
                    measureCommission.put("isInsert", true);
                }
                measureCommission.put("isRelationEAS", false);
                measureCommission.put("flowTo", "中转");
                measureCommission.put("IsAssembly", false);
                measureCommission.put("deliveryMethod", "磅重交货");
                measureCommission.put("packagesNum", 0);
                measureCommission.put("ReceivUnit","四川省达州钢铁集团有限责任公司");
                measureCommission.put("sendUnit","四川省达州钢铁集团有限责任公司");
                break;
            case 12:
            case 13:
                 //内转零星进厂（老厂区）
                //零星计量委托(老厂区)
                measureCommission = tmstruckMeasureCommissionMapper.sproadicMeasure(map);
                if(measureCommission == null){
                    return 0;
                }
                measureCommission.put("isRelationEAS",false);
                measureCommission.put("flowTo","进厂");
                measureCommission.put("isDel", false);
                measureCommission.put("isInsert", true);
                measureCommission.put("IsAssembly", false);
                measureCommission.put("deliveryMethod", "磅重交货");
                measureCommission.put("packagesNum", 0);
                break;
            case 15:
            case 16:
                //零星计量委托(老厂区)  会有多拼
                measureCommission = tmstruckMeasureCommissionMapper.sproadicMeasure(map);
                if(measureCommission == null){
                    return 0;
                }
                measureCommission.put("isRelationEAS",false);
                measureCommission.put("flowTo","出厂");
                measureCommission.put("isDel", false);
                measureCommission.put("isInsert", true);
                measureCommission.put("deliveryMethod", "磅重交货");
                measureCommission.put("packagesNum", 0);
                break;
            case 20://采购内转委托总厂区
                measureCommission=tmstruckMeasureCommissionMapper.purchaseXqCgNzMeasure(map);
                if(measureCommission == null){
                    return 0;
                }
                measureCommission.put("isRelationEAS",false);
                measureCommission.put("flowTo","进厂");
                measureCommission.put("isDel",false);
                measureCommission.put("isInsert",true);
                measureCommission.put("deliveryMethod", "磅重交货");
                measureCommission.put("packagesNum", 0);

        }
        /*访问接口发送数据*/
        System.out.println(measureCommission == null ? "没有查询出委托" : measureCommission);
        return 1;
//        return sendMesToMeasure(measureCommission);

    }


    /**
     * 发送计量委托给达兴能源 计量
     * @param map
     * @return
     */
    public int sendDXMeasureCommissionMes(Map<String, Object> map){
        Map<String, Object> measureCommission = null;
        //查询计量委托
        BigDecimal orderType = DataChange.dataToBigDecimal(map.get("orderTypee"));
        switch (orderType.intValue()){
            case 1:
            case 2:
            case 3:
                measureCommission = tmstruckMeasureCommissionMapper.saleDXMeasure(map); //订单ID  物资ID  计量实绩ID
                if(measureCommission == null)
                    return 0;
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("billType", "1");
                measureCommission.put("crname", "admin");
                measureCommission.put("ended", "0");
                break;
            case 4:
                break;
            case 5:
            case 6:
            case 7:
            case 8:
            case 17:
            case 18:
                measureCommission =  tmstruckMeasureCommissionMapper.purchaseDXMeasure(map);
                if(measureCommission == null)
                    return 0;
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("billType", "0");
                measureCommission.put("crname", "admin");
                measureCommission.put("ended", "0");
            case 9:
                break;
            case 10:
            case 20:
                //新区采购内转
                measureCommission = tmstruckMeasureCommissionMapper.purchaseXqCgNzDXMeasure(map);
                if(measureCommission == null)
                    return 0;
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("crname", "admin");
                //判断还没有净重的计量实绩
                Integer weightResultCount = tmstruckMeasureCommissionMapper.selectNoNetWeightResult(DataChange.dataToBigDecimal(map.get("resultTotalId")));
                if(weightResultCount == 1){
                    //如果只剩一条未计量的数据则需要走金蝶(进厂卸货)
                    measureCommission.put("orderSource", measureCommission.get("chooseOrderSource"));
                    measureCommission.put("billType", "0");
                    measureCommission.put("item", measureCommission.get("item") + ",1");
                    measureCommission.put("goodsName",measureCommission.get("goodsName") + "null");
                }else {
                    measureCommission.put("orderSource", "0");
                    measureCommission.put("billType", "2");
                }
                measureCommission.put("ended", "0");
                break;
            case 11:
                break;
            case 12:
            case 13:
            case 15:
            case 16:
                measureCommission = tmstruckMeasureCommissionMapper.sporadicDXMeasure(map);
                if(measureCommission == null)
                    return 0;
                measureCommission.put("regionName", "无法确定汽车衡"); //无法确定汽车衡
                measureCommission.put("deliveryType", "计重");
                measureCommission.put("billType", "2");
                measureCommission.put("planQuantity", "0");
                measureCommission.put("crname", "admin");
                measureCommission.put("orderSource", "0");
                measureCommission.put("ended", "0");
                break;
            
        }
        /*访问接口发送数据*/
        return sendMesToDXMeasure(measureCommission);
    }

    /**
     *
     * 访问老厂区计量接口方法
     * @param map
     * @return
     */
    public int sendMesToMeasure(Map<String, Object> map){
        List<Map<String, Object>> sendMap = new ArrayList<>();
        sendMap.add(map);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("data", sendMap);

        String url = "http://172.16.33.122:44325/api/logistics/TareApplyFor";
        String jsonData = null;
        try {
            jsonData = HTTPRequestUtils.send(url, jsonObject, "utf-8");
        } catch (IOException e) {
            e.printStackTrace();
        }
        if(!"null".equals(jsonData)){
            System.out.println(jsonData);
            HashMap hashMap = JSON.parseObject(jsonData, HashMap.class);
            boolean success = (boolean) hashMap.get("success");
            System.out.println(hashMap.get("msg"));
            if(success){
                return 1;
            }
        }else{
            System.out.println("委托发送失败：" + jsonData);
        }
        return 0;
    }


    /**
     * 访问新厂区达兴能源计量接口方法
     * @param map
     * @return
     */
    public int sendMesToDXMeasure(Map<String, Object> map){
        JSONObject jsonObject = new JSONObject();
        jsonObject.putAll(map);
        String url = "http://172.16.59.251:8121/daXingWeight/OrderBusiness/addOrder.do";
        String jsonData = null;
        try {
            jsonData = HTTPRequestUtils.send(url, jsonObject, "utf-8");
        } catch (IOException e) {
            e.printStackTrace();
        }
        if(!"null".equals(jsonData)){
            System.out.println(jsonData);
            HashMap hashMap = JSON.parseObject(jsonData, HashMap.class);
            String code = (String) hashMap.get("code");
            System.out.println(hashMap.get("msg"));
            if("0".equals(code)){
                return 1;
            }
        }
        return 0;
    }

    //发送计量委托
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int sendMeasureCommssion(Map<String, Object> map){
        int i=0;
        //获取订单类型
        BigDecimal orderId = DataChange.dataToBigDecimal(map.get("orderId"));
        BigDecimal orderType = utilsMapper.getOrderTypeByOrderId(orderId);
        map.put("orderTypee", orderType);
        //根据运输订单id查找运输订单号
        switch (orderType.intValue()){
            case 1: //查询未装车实绩
                List<Map<String, Object>> mapList = rulesService.judgeLastMaterial(DataChange.dataToBigDecimal(map.get("orderId")));
                map.put("materialId", mapList.get(0).get("materialId"));
                i+=addXSMeasureCommission(map);
            case 2:
            case 3: //通过物资ID查询订单ID（针对单拼）
                List<Integer> materialIdList = utilsMapper.getMaterialIdByOrderId(orderId);
                map.put("materialId", materialIdList.get(0));
                i+=addXSMeasureCommission(map);
                break;
            case 12:
            case 13:
            case 15:
            case 20:
            case 16: //发送计量委托(查询物资顺序第一个装卸货的物资)
                //拿到需要计量的物资ID
                Integer materialId = utilsMapper.getLxFirstMaterialId(DataChange.dataToBigDecimal(map.get("orderId")));
                map.put("materialId", materialId);
                i+=addLXMeasureCommission(map);
                break;
            case 5:
            case 6:
            case 7:
//            case 8:
//            case 9:
            case 10:
            case 11:
                i += addNZMeasureCommission(map);
                break;
//            case 17:
            case 18:
                i+=addMaoMeasureCommission(map);
        }
        return i;
    }

    /**
     * 添加内转委托
     * @Author TXF
     * @Date 2022/2/19 12:23
     * @param map
     * @return
     **/
    public int addNZMeasureCommission(Map<String, Object> map){
        int i = 0;
        addMeasureCommission(map); // 添加计毛委托
        i += sendMeasureCommissionMes(map); //往老厂区发送委托
        return i;
    }
}
